uniform sampler2D texture;
void main()
{
	vec3 n = vec3(0.0, 0.0, 0.01);
	float step = 1.0 / 1200.0;
	float xm = texture2D(texture, gl_TexCoord[0].st - vec2(step, 0.0)).r;
	float xp = texture2D(texture, gl_TexCoord[0].st + vec2(step, 0.0)).r;
	float zm = texture2D(texture, gl_TexCoord[0].st - vec2(0.0, step)).r;
	float zp = texture2D(texture, gl_TexCoord[0].st + vec2(0.0, step)).r;
	
	n.x -= xm;
	n.x += xp;
	n.y -= zm;
	n.y += zp;
	n = normalize(n);
	n = n * 0.5 + 0.5;
	
	vec3 light = vec3(0.0, 1.0, 0.0);	
	float diffuse = 1.0 - dot(n, light);
	gl_FragColor = vec4(diffuse, diffuse, diffuse, 1.0);
}
