uniform sampler2D texture;
uniform float time;
uniform float trans;
void main()
{
	vec4 result = texture2D(texture, gl_TexCoord[0].st);
	float t = gl_TexCoord[0].t;
	float s = gl_TexCoord[0].s;
	
	float bOkay = 2.0 * time - 1.0;
	float bThis = (t - s);
	if(bThis > bOkay)
	{
		float yCoord = t / 2.0;
		float xCoord = (1.0 - s) / 2.0;
		if(yCoord < time && xCoord < time)
		{
			float x = (t - bOkay);
			float y = (s + bOkay);
			float coef = 1.0;
			if(bThis < bOkay + 0.05)
			{
				float positiveDiff = (bThis - bOkay);
				coef = 1.0 + (0.05 - positiveDiff) * 15.0;
			}
			result = (coef * texture2D(texture, vec2(x, y)) + texture2D(texture, gl_TexCoord[0].st)) / 2.0;			
		}
		if(result.a < 0.0001)
		{
			gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
		}
		else
		{
			gl_FragColor = result;		                
			gl_FragColor.a = trans;
		}
	}
	else
	{
		gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
	}
}
